GROUP_DIRECTORY = "/afs/csail/group/rbg/"
GROUP_TOOLS_DIRECTORY = GROUP_DIRECTORY + "tools/bin/"
PROJECT_DIRECTORY = GROUP_DIRECTORY + "projects/title_gen/maxent/"
#PROJECT_DIRECTORY = '/scratch/title_gen/'

# Dataset names
DATASET_ALGORITHMS = "algorithms"
DATASET_PHYSICS_LECTURES = "physics_lectures"
DATASET_ALGORITHMS_RANDOMIZED = "algorithms_rnd"
DATASET_CIVIL = "civil"
DATASET_PHYSICS = "physics"
DATASET_MERCK = "merck"

# Datafile paths
DATAFILE_ALGORITHMS = GROUP_DIRECTORY + "corpora/Algorithms/algorithms.xml"
DATAFILE_PHYSICS_LECTURES = GROUP_DIRECTORY + "corpora/PhysicsLectures/physics_lectures.xml"
DATAFILE_ALGORITHMS_RANDOMIZED = GROUP_DIRECTORY + "corpora/Algorithms/algorithms_rnd_baseline.xml"
DATAFILE_CIVIL = GROUP_DIRECTORY + "corpora/Civil/civil.xml"
DATAFILE_PHYSICS = GROUP_DIRECTORY + "corpora/Physics/physics.xml"
DATAFILE_MERCK = GROUP_DIRECTORY + "corpora/MERCK/merck.xml"

# Sentence delimeters
SENTENCE_DELIMETERS = {}
SENTENCE_DELIMETERS[DATASET_ALGORITHMS] = "#SENTENCE#"
SENTENCE_DELIMETERS[DATASET_PHYSICS_LECTURES] = "#SENTENCE#"
SENTENCE_DELIMETERS[DATASET_ALGORITHMS_RANDOMIZED] = "#SENTENCE#"
SENTENCE_DELIMETERS[DATASET_CIVIL] = "[.?;!]+ "
SENTENCE_DELIMETERS[DATASET_PHYSICS] = "[.?;!]+ "
SENTENCE_DELIMETERS[DATASET_MERCK] = "[.?;!]+ "

# Tagger options
TAGGER_TEMP_DIR = "/tmp/"
TAGGER_OUTPUT_DIR = PROJECT_DIRECTORY + "data/tagged/"
TAGGER_PATH = GROUP_TOOLS_DIRECTORY + "taggers/mxpost/mxpost"

# Language model options
LANGUAGE_MODEL_TEMP_DIR = "/tmp/"
LANGUAGE_MODEL_SRILM_PATH = GROUP_TOOLS_DIRECTORY + "language_model/srilm/"
LANGUAGE_MODEL_NO_SMOOTHING_DEFAULT_LOG_PROB = -1000

# Maxent options
MAXENT_TEMP_DIR = "/tmp/"

MAXENT_ZHANGLE_EXEC_PATH = GROUP_TOOLS_DIRECTORY + "classifiers/zhangle_maxent/zhangle_maxent"

MAXENT_YASMET_EXEC_PATH = GROUP_TOOLS_DIRECTORY + "classifiers/yasmet_maxent/yasmet"
MAXENT_YASMET_DELTA_PP = 0.0
MAXENT_YASMET_ITERS = 100

# Negtive infinity constant
NEGATIVE_INFINITY = float('-inf')

# Stop word options
STOPWORDS_FILE_PATH = PROJECT_DIRECTORY + "stopwords.txt"
NUMBER_OF_STOPWORDS = 70

# Pickle path
PICKLE_PATH = PROJECT_DIRECTORY + "data/"

# This is a variable that is set to the current dataset name during runtime.
DATASET_NAME = ""
