import use_psyco
import utils, section, config, maxent, sys

#section_number = 383
window_size = 3
dataset_name = "algorithms"

def word_to_pos_tag(sec, word):
    for word_obj in sec.unique_word_objs:
        if word_obj.word == word:
            return word_obj.pos_tag

def make_word_by_string( word_string, sec ):
    if word_string == section.START_WORD.word: return section.START_WORD
    if word_string == section.END_WORD.word: return section.END_WORD

    word = section.Word( word_string )
    word.pos_tag = word_to_pos_tag( sec, word_string )
    return word

def evaluate_title( model, title_string, window, sec ):
    title_words = [ make_word_by_string(x, sec) for x in title_string.split(" ") ]

    history_words = title_words[:window-1]
    full_history = title_words[:window-1]
    in_title = False

    total_prob = 1.0
    print title_string
    print "-----------"
    for title_word in title_words[window-1:]:
        print ' '.join( [ x.word+"/"+str(x.pos_tag) for x in history_words ] ) + " " + title_word.word+"/"+str(title_word.pos_tag)
        # TODO: Pass previous section to Featuve Vector constructor instead of None
        prob = 0 #model.evaluate( [ maxent.FeatureVector(full_history, history_words, title_word, in_title, sec, None, model ) ] ) [0]
        lmwords = map (lambda x: x.word + '_' + x.pos_tag, history_words + [ title_word ] )
        print "tag_lm :"+str(model.tag_lm.get(lmwords))
        print "lang_lm :"+str(model.lexical_lm.get(lmwords))
        print prob
        print "--------------"
        history_words.append(title_word)
        history_words.pop(0)
        full_history.append(title_words)
        total_prob *= prob

    print "Total Prob: "+str(total_prob)

def main():
    config.DATASET_NAME = dataset_name
    lm = utils.load_lm()
    tag_lm = utils.load_tag_lm()
    stopwords_set = utils.load_stopwords_set()
    root_section = utils.load_section()
    s_model = utils.load_stem_model()
    m = maxent.Model( root_section, window_size, tag_lm, lm, stopwords_set, s_model )

    all_sec = root_section.get_descendants()
    title = "#start# #start# crcw pram the parallel computer #end#"
    evaluate_title(m, title, window_size, all_sec[383])
    print

    title = "#start# #start# who the public key cryptosystem #end#"
    evaluate_title(m, title, window_size, all_sec[476])
    print
        
    title = "#start# #start# nonsingular matrix inverse of an many nonzero #end#"
    evaluate_title(m, title, window_size, all_sec[399])
    print
    
    title = "#start# #start# this algorithm for the recursive section #end#"
    evaluate_title(m, title, window_size, all_sec[401])
    print

if __name__ == '__main__':
    sys.exit( main( ) )

