

class ParseTree:

	def __init__ (self):
		self.parent = None
		self.children = []
		self.tag = ''
		self.text = ''

	#-----------------------------------------------
	def load_from_file (self, filename):
		f = open (filename)
		text = f.readline ();
		f.close ()

		print (text)
		self.parse (text)
		
	#-----------------------------------------------
	def parse (self, parse_text):
		tag_found = False
		node = None
		
		for ch in parse_text:
			if ch == '(':
				if node == None:
					node = self
				else:
					child = ParseTree ()
					node.children.append (child)
					child.parent = node
					node = child
				tag_found = False

			elif ch == ')':
				if node == self:
					return
				else:
					node = node.parent

			elif ch == ' ':
				tag_found = True

			else:
				if tag_found == False:
					node.tag += ch
				
				else:
					node.text += ch

	def __str__ (self, indent=0):
		for i in range (indent):
			print ('  '),

		print ('(' + self.tag + ', ' + self.text + ')')

		for child in self.children:
			child.draw (indent + 1)
