import utils

def get_stopwords_set( training_sections, top_k ):
    # Build list of most popular words in section bodies
    body_word_to_count = {}
    for sec in training_sections:
        for sentence in sec.body:
            for word in sentence.words:
                body_word_to_count[word.word] = body_word_to_count.get(word.word, 0) + 1

    # Build list of least popular words in titles
    title_word_to_count = {}
    for sec in training_sections:
        for title_word in sec.title.words:
            title_word_to_count[title_word.word] = title_word_to_count.get(title_word.word, 0) + 1

    occurences_in_body_into_title = {}
    for word in body_word_to_count.keys():
        #occurences_in_body_into_title [ word ] = 1.0 * body_word_to_count[ word ] / title_word_to_count.get( word, 1) + 1
        if title_word_to_count.get( word, 0) == 0:
            occurences_in_body_into_title [ word ] = 1.0 * body_word_to_count[ word ]

    stopwords = utils.sort_dict_by_values(occurences_in_body_into_title)
    return set( stopwords[-top_k:] )
